clc,clear;  
%input = inputdlg(prompt,dlg_title,num_lines,defAns)
prompt={'Channel number:','Inlet buffer flow rate (uL/min):'};  %input parameter numbers
words='Input parameters';  %title
input=inputdlg(prompt,words,[1 50;1 50],{'4','1'});  %preset parameters
input=cellfun(@str2double,input);  %transfer cell to be matrix
N=input(1);  %outlet number
Qin1=input(2);  %inlet flow rate(uL/min), the outlet flow rates are the same
%% parameters for calculation
HS=1.66666667e-11;  %transfer number from uL/min to m^3/s
Qin=Qin1*HS;  %inlet pressure
N1=N-1;  %the number for channels without mixing
%% dilution method
physlist = {'2','sqrt(10)','linear (k=1/(N+1))'};  %preset three chooses
[sel,ok]=listdlg('PromptString','Please choose dilution factor', 'ListString', physlist, ...
    'listsize',[400 200],'OkString','OK','CancelString','Cancel',...
    'name','Output parameters','selectionmode','single'); 
if sum(sel)<=1 %choose first one
    X=2;  %X is the dilute time in each junction
    else if sum(sel)<=2 %choose second one
            X=sqrt(10);  
            else if sum(sel)<=4  %choose third one
                    X=N+1;  
                end
      end
end
%% concentration calculation
C=ones(1,N); %build a ones matrix for concentration
Q=zeros(N,4);  %build a zeros matrix for flow rate
Q(1,2)=X*Qin;  %the inlet flow rate in first junction, equal the flow rate sum of sample and first buffer
if sum(sel)<=2  %for first two sections
    for i=1:N
        C(i)=1/X^(i);  %concentration in each stage
    end
    else if sum(sel)<=3 %for thrid section
        for i=1:N
            C(i)=1-i/X;  %concentration in each stage
        end
    end
end
%%  channel size parameters
L1=3e-3;  %channel length before mixing junction
L2=20e-3;  %channel length for mixing junction    
L3=20e-3;  %channel length between two stages
L44=5e-3;  %channel length for last outlet channel
Lv=300e-6; %valve length
w=200e-6;  %channel width for channels except valve region
wv=50e-6;  %valve width
h=50e-6;  %channel height for all part
Lc=10e-3;  %channel length for concentration channel
wc=1e-3;  %channel width for concentration channel
%% flow rate calculation
u=1.01e-3;  %dynamic viscosity
A=w*h;  Av=wv*h;  Ac=wc*h;  %cross section area
P=2*(w+h);  Pv=2*(wv+h);  Pc=2*(wc+h);  %cross section perimeter
rh=2*A/P;  rhv=2*Av/Pv;  rhc=2*Ac/Pc;  %hydraulic radius
R=(8*u*Lv)/(Av*rhv^2); %flow resistance 
%% flow rate in each part
Q(:,1)=Qin; %flow rate in each buffer inlet,0.02uL/min
for j=1:N1
    Q(j,3)=(Qin*C(j+1))/(C(j)-C(j+1));  %flow rate in each shunt channels, the last output doesn't have shunt
end
for k=2:N
    Q(k,2)=Qin+Q(k-1,3);  %flow rate in each mixing channels, the first mixing region doesn't need to calculate
end
for l=1:N1
    Q(l,4)=Q(l,2)-Q(l,3);  %flow rate in each output
end
Q(N,4)=Q(N,2); %in last junction, output flow rate is mixing flow rate
%% flow resistance calculation
R=zeros(N,6);  %build a zeros matrix for flow rate
R(1:N,2)=(12*u*L2)/(w*h^3*(1-0.63*h/w));  %flow resistance in mixing region
R(1:N1,3)=(12*u*L3)/(w*h^3*(1-0.63*h/w));  %flow resistance in shunt channel
R(N,4)=(8*u*L44)/((rhv^2)*Av);  %flow resistance before concentration channel in last output channel
R(N,5)=(12*u*Lc)/(wc*h^3*(1-0.63*h/wc));  %flow resistance in concentration channel
R(N,6)=R(N,4)+R(N,5);  %flow resistance in whole last output channel
for m=N1:-1:1
    R(m,6)=(Q(m,3)*R(m,3)+Q(m+1,4)*R(m+1,6)+Q(m+1,2)*R(m+1,2))/Q(m,4);  %flow resistance in each output channel
    R(m,5)=R(N,5);
    R(m,4)=R(m,6)-R(m,5);
end    
R(:,1)=(12*u*L1)/(w*h^3*(1-0.63*h/w));  %flow resistance before mixing junction
%% channel length for each output channel
if w>h
    L=R*(w*h^3*(1-0.63*h/w))/(12*u);  
else 
    L=R*(rh^2)*A/(8*u);
end
L(:,4)=R(:,4)*(rhv^2)*Av/(8*u);   %channel length before concentration channel in last output channel
Lum=L*1e3;  %transfer length to be um
%% inlet pressure calculation
for n=1:N
    Pin(n)=Q(n,1)*R(n,1)+Q(n,2)*R(n,2)+Q(n,4)*R(n,4);  %inlet pressure in each buffer inlet
end
Pin1=(Q(1,2)-Q(l,1))*R(1,1)+Q(1,2)*R(1,2)+Q(1,3)*R(1,3);  %inlet pressure in each sample inlet